/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.gameproject.multiplayerpaddle;

import java.util.Set;

import android.annotation.TargetApi;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

/**
 * Ta Aktywność pojawia się w postaci okna dialogowego z wymienionymi wszystkimi sparowanymi urządzeniami
 * a także urządzeniami wykrytymi w obszarze otoczenia. Po wybraniu urządzenia,When a device is chosen
 * jego adres MAC jest odsyłany do nadrzędnej Aktywności 
 */
@TargetApi(11)
public class DeviceListActivity extends Activity {
    // Debugowanie
    private static final String TAG = "DeviceListActivity";
    private static final boolean D = true;

    public static String EXTRA_DEVICE_ADDRESS = "device_address";

    // Pola klasy
    private BluetoothAdapter mBtAdapter;
    private ArrayAdapter<String> mPairedDevicesArrayAdapter;
    private ArrayAdapter<String> mNewDevicesArrayAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Nowe okno
        requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
        setContentView(R.layout.device_list);

        // W przypadku anulowania ustaw wynik CANCELED
        setResult(Activity.RESULT_CANCELED);

        // Utwórz przycisk do przeszukiwania otoczenia
        Button scanButton = (Button) findViewById(R.id.button_scan);
        scanButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                doDiscovery();
                v.setVisibility(View.GONE);
            }
        });

        // Inicjalizacja tablic. Jednej dla aktualnie sparowanych urządzeń i drugiej dla nowo odkrytych
        mPairedDevicesArrayAdapter = new ArrayAdapter<String>(this, R.layout.device_name);
        mNewDevicesArrayAdapter = new ArrayAdapter<String>(this, R.layout.device_name);

        // Konfiguracja widoku listy dla sparowanych urządzeń
        ListView pairedListView = (ListView) findViewById(R.id.paired_devices);
        pairedListView.setAdapter(mPairedDevicesArrayAdapter);
        pairedListView.setOnItemClickListener(mDeviceClickListener);

        // Konfiguracja widoku listy dla nowo wykrytych urządzeń
        ListView newDevicesListView = (ListView) findViewById(R.id.new_devices);
        newDevicesListView.setAdapter(mNewDevicesArrayAdapter);
        newDevicesListView.setOnItemClickListener(mDeviceClickListener);

        // Zarejestruj nadawanie po wykryciu urządzenia
        IntentFilter filter = new IntentFilter(BluetoothDevice.ACTION_FOUND);
        this.registerReceiver(mReceiver, filter);

        // Zarejestruj nadawnie po zakończeniu wykrywania
        filter = new IntentFilter(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
        this.registerReceiver(mReceiver, filter);

        // Pobierz lokalny adapter Bluetooth
        mBtAdapter = BluetoothAdapter.getDefaultAdapter();

        // Pobierz zestaw aktualnie sparowanych urządzeń
        Set<BluetoothDevice> pairedDevices = mBtAdapter.getBondedDevices();

        // W przypadku istnienia urządzeń sparowanych dodaj je do obiektu ArrayAdapter
        if (pairedDevices.size() > 0) {
            findViewById(R.id.title_paired_devices).setVisibility(View.VISIBLE);
            for (BluetoothDevice device : pairedDevices) {
                mPairedDevicesArrayAdapter.add(device.getName() + "\n" + device.getAddress());
            }
        } else {
            String noDevices = getResources().getText(R.string.none_paired).toString();
            mPairedDevicesArrayAdapter.add(noDevices);
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        // Upewnij się że nie jest wykonywane ponowne wykrywanie
        if (mBtAdapter != null) {
            mBtAdapter.cancelDiscovery();
        }

        // Usuń rejestrację metod nasłuchujących
        this.unregisterReceiver(mReceiver);
    }

    /**
     * Uruchom wykrywaie urządzeń za pomocą obiektu BluetoothAdapter
     */
    private void doDiscovery() {
        if (D) Log.d(TAG, "doDiscovery()");

        //  Sygnalizuj wyszukiwanie w nagłówku
        setProgressBarIndeterminateVisibility(true);
        setTitle(R.string.scanning);

        // Dla nowych urządzeń wyświetl listę
        findViewById(R.id.title_new_devices).setVisibility(View.VISIBLE);

        // Zakończ ewentualne równoległę wykrywanie
        if (mBtAdapter.isDiscovering()) {
            mBtAdapter.cancelDiscovery();
        }

        // Zarządaj wyszukiwania od obiektu klasy BluetoothAdapter
        mBtAdapter.startDiscovery();
    }

    // Metoda nasłuchująca kliknięcia na liście urządzeń 
    private OnItemClickListener mDeviceClickListener = new OnItemClickListener() {
        public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {
            // Zakończ wyszukiwanie ponieważ jest ono kosztowne a zaraz zostanie nawiązanie połączenie
            mBtAdapter.cancelDiscovery();

            // Pobierz adres MAC
            String info = ((TextView) v).getText().toString();
            String address = info.substring(info.length() - 17);

            Intent intent = new Intent();
            intent.putExtra(EXTRA_DEVICE_ADDRESS, address);

            // Wyślij wynik i zakończ aktywność
            setResult(Activity.RESULT_OK, intent);
            finish();
        }
    };

    //  BroadcastReceiver nasłuchujący wykrytych urządzeń i zmieniający nagłówek po wykryciu urządzenia

    private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();

            // Kiedy wyszukiwanie odkryje urządzenie
            if (BluetoothDevice.ACTION_FOUND.equals(action)) {
                // Pobierz obiekt BluetoothDevice 
                BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
                // Jeżeli jest już sparowane pomiń
                if (device.getBondState() != BluetoothDevice.BOND_BONDED) {
                    mNewDevicesArrayAdapter.add(device.getName() + "\n" + device.getAddress());
                }
            // Po skończeniu wyszukiwania, zmień nagłówek Aktywności
            } else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED.equals(action)) {
                setProgressBarIndeterminateVisibility(false);
                setTitle(R.string.select_device);
                if (mNewDevicesArrayAdapter.getCount() == 0) {
                    String noDevices = getResources().getText(R.string.none_found).toString();
                    mNewDevicesArrayAdapter.add(noDevices);
                }
            }
        }
    };

}
